<%--
  Created by IntelliJ IDEA.
  User: Cameron Johnson
  Date: 1-Nov-2005
  Time: 2:17:01 PM
  To change this template use File | Settings | File Templates.
--%>
<%@ page contentType="text/xml;charset=UTF-8" language="java" %>
<%@ page import="AllbarCodes.BarcodeGenerator"%>
<%@ page import="sun.misc.BASE64Encoder"%>
<%@ page import="java.io.PrintWriter"%>
<%
	String imageString = null;
	try
	{
		String temp;
		byte[] datain;
		boolean incText = false;
		BarcodeGenerator codes;
		boolean desktop = false;

		//In this next section of code we are retrieving the parameters passed by the lookup 
		//to be able to generate the barcode to thier specifications.
		temp = request.getParameter("data");
		if (temp != null)
			 datain = temp.getBytes();
		else
			throw new Exception("No data to generate barcode.");

		String barType = request.getParameter("barcodeType");
		if (barType == null)
			throw new Exception("No barcode format specified");

		String cellName = request.getParameter("cellName");
		if (cellName == null)
			throw new Exception("No cell to place barcode");

		codes = new BarcodeGenerator();

		temp = request.getParameter("degree");
		if(temp != null)
			codes.setOrientation(Integer.parseInt(temp));

		temp = request.getParameter("res");
		if(temp != null)
			codes.setResolution(Integer.parseInt(temp));

		temp = request.getParameter("aspect");
		if(temp != null)
			codes.setAspectRatio(Short.parseShort(temp));

		temp = request.getParameter("error");
		if(temp != null)
			codes.setErrorCorrection(Short.parseShort(temp));

		temp = request.getParameter("incText");
		if(temp != null)
		{
			if (temp.toLowerCase().equals("true"))
				incText = true;
			else
				incText = false;
			codes.IncludeText(incText);
		}

		if(incText)
		{
			codes.setReadableText(request.getParameter("includedText"));
		}

		//This next six lines is a check to see if the lookup was triggered by Desktop eForms.
		temp = request.getParameter("hex");
		if(temp != null)
		{
			if(Integer.parseInt(temp) == 1)
				desktop = true;
		}

		//This is a where the barcode is renedered to an image.
		byte[] image = null;
		if (barType.equals("Code39"))
			image = codes.RenderCode39(datain);
		else if (barType.equals("Code128"))
			image = codes.RenderCode128(datain);
		else if (barType.equals("PDF417"))
			image = codes.RenderCodePDF417(datain);
		else
			throw new Exception("Unknown barcode format");


		if (desktop)
		{
			//This section of will convert the byte array to a Hex string and prepend a 
			//image type value to the front so that Desktop eForms will be able to use the image.
			imageString = BarcodeGenerator.ConvertByteArrayToHexString(image);
		}
		else
		{
			//This section will convert the byte array to a BASE64 string for HTML eForms to be alble to use the image. 
			BASE64Encoder encoder = new BASE64Encoder();
			imageString = encoder.encode(image);
		}

		//This section will render the output to be passed back to the Form.
		PrintWriter output = response.getWriter();
		response.setContentType("text/xml");
		output.write("<eformLookup><instance><" + cellName);
		output.write(">" + imageString + "</");
		output.write(cellName + "></instance></eformLookup>");
	}
	catch (Exception ex)
	{
		response.sendError(404, ex.getMessage());
	}
%>
